#ifndef INTERFACE_H
#define INTERFACE_H

struct complex
{
   float real;
   float imag;
};

typedef struct complex complex;

#ifndef TRUE
#define TRUE    1
#endif
#ifndef FALSE
#define FALSE   0
#endif

/*
   The variables a, b and c will be replaced by the user parameters
   directly.
   No type checking is done.
   Do not even think of using anything other than variable names
   as parameters.

   This macro is tested in test_interface.c.

 */

/* c = a + b */
#define add(a,b,c)                                       \
{                                                        \
   (c).real = (a).real + (b).real;                       \
   (c).imag = (a).imag + (b).imag;                       \
}

/* c = a - b */
#define subtract(a,b,c)                                  \
{                                                        \
   (c).real = (a).real - (b).real;                       \
   (c).imag = (a).imag - (b).imag;                       \
}

/* c = a * b */
#define multiply(a,b,c)                                  \
{                                                        \
   (c).real = (a).real * (b).real - (a).imag * (b).imag; \
   (c).imag = (a).real * (b).imag + (a).imag * (b).real; \
}

/* c = a / b */
#define division(a, b, c)                                  \
{                                                        \
   double dem;                                           \
                                                         \
   (c).real = (a).real * (b).real + (a).imag * (b).imag; \
   (c).imag = (a).imag * (b).real - (a).real * (b).imag; \
                                                         \
   dem = (b).real * (b).real + (b).imag * (b).imag;      \
                                                         \
   (c).real /= dem;                                      \
   (c).imag /= dem;                                      \
}

#endif

#include<stdio.h>


